﻿###############################################################################
function NewFOPTConsumer_ConOut(){
###############################################################################
	$fs=@(); #for storing the function/method script blocks
	$me= #for storing the objects properties
	###########################################################################
	@{
		__Version        = 0.1;
		FOPTracker       = $null;
		Prefix           = ""; #[TrackerName]
	}
	###########################################################################
	function constructor(){}
	###########################################################################
	$fs+=,@('_Init', { param( $FOPTracker )
	###########################################################################
		$this.FOPTracker = $FOPTracker;
		
        $this.Prefix      = $this.FOPTracker.LogPrefix+".ConOut : ";
	});
	###########################################################################
	$fs+=,@('OnCreate', { param( $op )
		LogOut "$($this.Prefix)Created [$($op.filePath)]";
	});
	###########################################################################
	$fs+=,@('OnChange', { param( $op )
		LogOut "$($this.Prefix)Changed [$($op.filePath)]";
	});
	###########################################################################
	$fs+=,@('OnRename', { param( $op )
		LogOut "$($this.Prefix)Renamed [$($op.filePathOld)] -> [$($op.filePath)]";
	});
	###########################################################################
	$fs+=,@('OnMove', { param( $opDelete, $opCreate, $opMerged )
		LogOut "$($this.Prefix)Moved   [$($opDelete.filePath)] -> [$($opCreate.filePath)]";
	});
	###########################################################################
	$fs+=,@('OnReplace', { param( $op)
        LogOut "$($this.Prefix)Replacd [$($op.filePath)]";
	});
	###########################################################################
	$fs+=,@('OnDelete', { param( $op )
		LogOut "$($this.Prefix)Deleted [$($op.filePath)]";
	});
	###########################################################################
	$me.__Type = (gv MyInvocation -Scope 0).Value.MyCommand.Name -replace "^NEW-?", "";
	if (!$me.ContainsKey("__Version")){ $me.__Version = 0;}
	$this=new-object -typename 'System.Management.Automation.PSObject' -property $me;
	foreach($function in $fs){
		$this | add-member -me scriptmethod -na $function[0] -va $function[1]; }
	###########################################################################
	constructor;
	return $this;
}